---
title: Media Session API
slug: Web/API/Media_Session_API
tags:
  - Audio
  - Media
  - Media Session API
  - MediaMetadata
  - MediaSession
  - Overview
  - Reference
  - Video
---
<p>{{DefaultAPISidebar("Media Session API")}}</p>

<p class="summary">The Media Session API provides a way to customize media notifications. It does this by providing metadata for display by the user agent for the media your web app is playing.</p>

<p class="summary">It also provides action handlers that the browser can use to access platform media keys such as hardware keys found on keyboards, headsets, remote controls, and software keys found in notification areas and on lock screens of mobile devices. So you can seamlessly control web-provided media via your device, even when not looking at the web page.</p>

<p class="summary">The aim is to allow users to know what's playing and to control it, without needing to open the specific page that launched it. To be able to support the Media Session API, a browser first needs a mechanism by which to access and be controlled by the OS-level media controls (such as Firefox's <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1648100">MediaControl</a>).</p>

<h2 id="Media_Session_concepts_and_usage">Media Session concepts and usage</h2>

<p>The {{domxref("MediaMetadata")}} interface lets a web site provide rich metadata to the platform UI for media that is playing. This metadata includes the title, artist (creator) name, album (collection), and artwork. The platform can show this metadata in media centers, notifications, device lockscreens, etc.</p>

<p>The {{domxref("MediaSession")}} interface lets users control playback of media through user-agent defined interface elements. Interaction with these elements triggers action handlers in the web page, playing the media. Since multiple pages may be simultaneously using this API, the user agent is responsible for calling the correct page's action handlers. The user agent provides default behaviors, when no page-defined behavior is available.</p>

<h2 id="Accessing_the_Media_Session_API">Accessing the Media Session API</h2>

<p>The primary interface for the Media Session API is the {{domxref("MediaSession")}} interface. Rather than creating your own <code>MediaSession</code> instance, you access the API using the {{domxref("navigator.mediaSession")}} property. For example, to set the current state of the media session to <code>playing</code>:</p>

<pre class="brush: js notranslate">navigator.mediaSession.playbackState = "playing";</pre>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("MediaMetadata")}}</dt>
 <dd>Allows a web page to provide rich media metadata for display in a platform UI.</dd>
 <dt>{{domxref("MediaSession")}}</dt>
 <dd>Allows a web page to provide custom behaviors for standard media playback interactions.</dd>
</dl>

<h2 id="Dictionaries">Dictionaries</h2>

<dl>
 <dt>{{domxref("MediaImage")}}</dt>
 <dd>A <code>MediaImage</code> object contains information describing an image associated with the media. This might be a CD or DVD cover, a movie poster, a poster frame, or the like.</dd>
 <dt>{{domxref("MediaPositionState")}}</dt>
 <dd>Used to contain information about the current playback position, playback speed, and overall media duration when calling the {{domxref("MediaSession")}} method {{domxref("MediaSession.setPositionState", "setPositionState()")}} to establish the media's length, playback position, and playback speed.</dd>
 <dt>{{domxref("MediaSessionActionDetails")}}</dt>
 <dd>Provides information needed in order to perform the action that has been requested, including the type of action to perform and any other information needed, such as seek distances or times.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example shows feature detection for the Media Session API. It then instantiates a metadata object for the session, and adds action handlers for the user control actions:</p>

<pre class="brush: js notranslate">if ('mediaSession' in navigator) {
  navigator.mediaSession.metadata = new MediaMetadata({
    title: 'Unforgettable',
    artist: 'Nat King Cole',
    album: 'The Ultimate Collection (Remastered)',
    artwork: [
      { src: 'https://dummyimage.com/96x96',   sizes: '96x96',   type: 'image/png' },
      { src: 'https://dummyimage.com/128x128', sizes: '128x128', type: 'image/png' },
      { src: 'https://dummyimage.com/192x192', sizes: '192x192', type: 'image/png' },
      { src: 'https://dummyimage.com/256x256', sizes: '256x256', type: 'image/png' },
      { src: 'https://dummyimage.com/384x384', sizes: '384x384', type: 'image/png' },
      { src: 'https://dummyimage.com/512x512', sizes: '512x512', type: 'image/png' },
    ]
  });

  navigator.mediaSession.setActionHandler('play', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('pause', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('stop', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('seekbackward', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('seekforward', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('seekto', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('previoustrack', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('nexttrack', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('skipad', function() { /* Code excerpted. */ });
}</pre>

<p>Some user agents disable autoplay for media elements on mobile devices and require a user gesture to start media. The following example adds a <code>pointerup</code> event to an on-page play button, which is then used to kick off the media session code:</p>

<pre class="brush: js notranslate">playButton.addEventListener('pointerup', function(event) {
  var audio = document.querySelector('audio');

  // User interacted with the page. Let's play audio...
  audio.play()
  .then(_ =&gt; { /* Set up media session controls, as shown above. */ })
  .catch(error =&gt; { console.log(error) });
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Session')}}</td>
   <td>{{Spec2('Media Session')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.MediaSession")}}</p>
